#include "mymodel.h"

MyModel::MyModel(QObject *parent) :
      QSqlTableModel(parent)
{
    setEditStrategy(QSqlTableModel::OnManualSubmit);
}

Qt::ItemFlags MyModel::flags(
         const QModelIndex &index) const {
Qt::ItemFlags flags = QSqlTableModel::flags(index);
if ((index.column() != 3) && (index.column() != 0) /* && (index.column() != 5)*/)
     flags |= Qt::ItemIsEditable;
//if (index.column() == 4)
//     flags |= Qt::ItemIsUserCheckable;
else
{
    if ((index.column() == 3) || (index.column() == 0) /* || (index.column() == 5)*/) flags &= ~Qt::ItemIsEditable; //   0, 3  5 
}
    return flags;
}


bool MyModel::setData(const QModelIndex &index, const QVariant &value, int role) {
  ////  if (index.column()==3) return false; //       
    bool lResult = false;

    /*
    QString str_tmp;
    if (index.column()==1) {                //    
        str_tmp = value.toString();         //     
        str_tmp.append(tr(" instance"));
      }
      */
/*
    QString str_tmp;
    if (index.column()==0) {                //    
        str_tmp = value.toString();         //     
        str_tmp.append(tr("_instance"));
      }
*/
    lResult = QSqlTableModel::setData(index, value, role);

 //   if (index.column() == 5) return lResult;
    if (lResult) {
        QModelIndex newindex;
        QSqlRecord rec = record(index.row());

        if (value.isNull()) {
        rec.setNull(index.column());

        }
        else rec.setValue(index.column(), value);

        rec.setGenerated(index.column(), true);

        /*
        if (index.column()==1){
            rec.setValue(index.column()+2, QVariant(str_tmp));
            rec.setGenerated(index.column()+2, true);
            newindex = MyModel::index(index.row(), index.column()+2);
            QSqlTableModel::setData(newindex, QVariant(str_tmp), Qt::EditRole);
        }
        */
/*

        if (index.column()==0){
            rec.setValue(index.column()+3, QVariant(str_tmp));
            rec.setGenerated(index.column()+3, true);
            newindex = MyModel::index(index.row(), index.column()+3);
            QSqlTableModel::setData(newindex, QVariant(str_tmp), Qt::EditRole);
        }
*/

        lResult = updateRowInTable(index.row(), rec);
  ///      QSqlTableModel::setData(newindex, QVariant(str_tmp), Qt::EditRole);
  //          submitAll();
   //         this->select();

    }
    if (value.isNull()) {
        select();
        emit dataChanged(index, index);
    }
    return lResult;
}



QVariant MyModel::data(const QModelIndex &index, int role) const {

     QVariant value = QSqlTableModel::data(index, role);
  switch (role) {
        case Qt::DisplayRole: return value;
        case Qt::EditRole: return value;
        case Qt::TextColorRole:
            if(index.column() == 1)
                return qVariantFromValue(QColor(Qt::blue));
            else
              return value;
        case Qt::TextAlignmentRole: return value;
        case Qt::FontRole:
           if(index.column() == 1) {
               QFont font = QFont("Helvetica", 16, QFont::Bold);
              return qVariantFromValue(font);
           }else
               return value;

       case Qt::BackgroundColorRole: {
                int a = (index.row() % 2) ? 14 : 0;
                if(index.column() == 2)
                           return qVariantFromValue(QColor(220,240-a,230-a));
                        else if(index.column() == 4)
                            return qVariantFromValue(QColor(200,220-a,255-a));
                        else
                           return value;
                                    }



     case Qt::CheckStateRole: return value;

     case Qt::SizeHintRole:
              {

             int height = value.toSize().height();
             int widht = value.toSize().width();
             if(index.column() == 5) {
                               QVariant currentImage = QSqlTableModel::data(index, 0);
                               QByteArray bytes = currentImage.toByteArray();
                               QPixmap pxmp;


                               if (currentImage.isValid()) {
                                    pxmp.loadFromData(bytes);
                                    if (height < pxmp.height()) height =  pxmp.height() +10;
                                    if (widht < pxmp.width()) widht = pxmp.width() +10;
                                    return QVariant(QSize(widht, height));

                                }
                               else return value;

                           }


        //     QSize size(200,100);

                 return value;
          //        return QVariant(size);
              }

      case Qt::DecorationRole: {
              if(index.column() == 1) return iconProvider.icon(QFileIconProvider::Folder);
              else return QVariant();
              /*{
                  QVariant currentImage = QSqlTableModel::data(index, 0);
                  QByteArray bytes = currentImage.toByteArray();
                  QPixmap pxmp;
                  if (currentImage.isValid()) {
                       pxmp.loadFromData(bytes);
                       QIcon icon;
                       icon.addPixmap(pxmp);
                       return icon;

                  }
                  else {
                      //QItemDelegate::paint(painter, option, index);
                  return value;
                  }

              }
       */

          }



     }
  return value;
}

